diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_gcd.c openssl-1.0.0q/crypto/bn/bn_gcd.c
--- openssl-1.0.0q.orig/crypto/bn/bn_gcd.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_gcd.c	2017-04-25 16:23:40.074527067 +0200
@@ -109,7 +109,7 @@
  *
  */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 static BIGNUM *euclid(BIGNUM *a, BIGNUM *b);
@@ -201,7 +201,6 @@
 	return(NULL);
 	}
 
-
 /* solves ax == 1 (mod n) */
 static BIGNUM *BN_mod_inverse_no_branch(BIGNUM *in,
         const BIGNUM *a, const BIGNUM *n, BN_CTX *ctx);
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_lcl.h openssl-1.0.0q/crypto/bn/bn_lcl.h
--- openssl-1.0.0q.orig/crypto/bn/bn_lcl.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_lcl.h	2017-04-25 16:23:40.075526914 +0200
@@ -323,33 +323,6 @@
 	(r1)=Hw(t); \
 	}
 
-#elif defined(BN_UMULT_LOHI)
-#define mul_add(r,a,w,c) {		\
-	BN_ULONG high,low,ret,tmp=(a);	\
-	ret =  (r);			\
-	BN_UMULT_LOHI(low,high,w,tmp);	\
-	ret += (c);			\
-	(c) =  (ret<(c))?1:0;		\
-	(c) += high;			\
-	ret += low;			\
-	(c) += (ret<low)?1:0;		\
-	(r) =  ret;			\
-	}
-
-#define mul(r,a,w,c)	{		\
-	BN_ULONG high,low,ret,ta=(a);	\
-	BN_UMULT_LOHI(low,high,w,ta);	\
-	ret =  low + (c);		\
-	(c) =  high;			\
-	(c) += (ret<low)?1:0;		\
-	(r) =  ret;			\
-	}
-
-#define sqr(r0,r1,a)	{		\
-	BN_ULONG tmp=(a);		\
-	BN_UMULT_LOHI(r0,r1,tmp,tmp);	\
-	}
-
 #elif defined(BN_UMULT_HIGH)
 #define mul_add(r,a,w,c) {		\
 	BN_ULONG high,low,ret,tmp=(a);	\
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_lib.c openssl-1.0.0q/crypto/bn/bn_lib.c
--- openssl-1.0.0q.orig/crypto/bn/bn_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_lib.c	2017-04-25 16:23:40.076527321 +0200
@@ -61,13 +61,19 @@
 # define NDEBUG
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <assert.h>
 #include <limits.h>
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
+#include "modules/libopeay/libopeay_arrays.h"
 
-const char BN_version[]="Big Number" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char BN_version[]="Big Number" OPENSSL_VERSION_PTEXT;/* ARRAY OK 2007-02-27 haavardm */ 
+#endif
 
 /* This stuff appears to be completely unused, so is deprecated */
 #ifndef OPENSSL_NO_DEPRECATED
@@ -80,6 +86,24 @@
  * 7 - 128 == 4096
  * 8 - 256 == 8192
  */
+#ifdef _NO_GLOBALS_
+extern int *g_bn_limit_bits_addr();
+#define bn_limit_bits (*g_bn_limit_bits_addr())
+extern int *g_bn_limit_num_addr();
+#define bn_limit_num (*g_bn_limit_num_addr())
+extern int *g_bn_limit_bits_low_addr();
+#define bn_limit_bits_low (*g_bn_limit_bits_low_addr())
+extern int *g_bn_limit_num_low_addr();
+#define bn_limit_num_low (*g_bn_limit_num_low_addr())
+extern int *g_bn_limit_bits_high_addr();
+#define bn_limit_bits_high (*g_bn_limit_bits_high_addr())
+extern int *g_bn_limit_num_high_addr();
+#define bn_limit_num_high (*g_bn_limit_num_high_addr())
+extern int *g_bn_limit_bits_mont_addr();
+#define bn_limit_bits_mont (*g_bn_limit_bits_mont_addr())
+extern int *g_bn_limit_num_mont_addr();
+#define bn_limit_num_mont (*g_bn_limit_num_mont_addr())
+#else
 static int bn_limit_bits=0;
 static int bn_limit_num=8;        /* (1<<bn_limit_bits) */
 static int bn_limit_bits_low=0;
@@ -88,6 +112,7 @@
 static int bn_limit_num_high=8;   /* (1<<bn_limit_bits_high) */
 static int bn_limit_bits_mont=0;
 static int bn_limit_num_mont=8;   /* (1<<bn_limit_bits_mont) */
+#endif
 
 void BN_set_params(int mult, int high, int low, int mont)
 	{
@@ -131,12 +156,18 @@
 	}
 #endif
 
+static const BN_ULONG data_one=1L;
+OPENSSL_PREFIX_CONST_ITEM(static, BIGNUM, const_one, libopeay)
+	CONST_ITEM_ENTRY_START(d, (BN_ULONG *) &data_one)
+	CONST_ITEM_ENTRY_SINGLE(top,1)
+	CONST_ITEM_ENTRY_SINGLE(dmax,1)
+	CONST_ITEM_ENTRY_SINGLE(neg,0)
+	CONST_ITEM_ENTRY_SINGLE(flags,BN_FLG_STATIC_DATA)
+	CONST_ITEM_ENTRY_END;
+
 const BIGNUM *BN_value_one(void)
 	{
-	static const BN_ULONG data_one=1L;
-	static const BIGNUM const_one={(BN_ULONG *)&data_one,1,1,0,BN_FLG_STATIC_DATA};
-
-	return(&const_one);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(const_one));
 	}
 
 char *BN_options(void)
@@ -291,7 +322,7 @@
 
 void BN_init(BIGNUM *a)
 	{
-	memset(a,0,sizeof(BIGNUM));
+	op_memset(a,0,sizeof(BIGNUM));
 	bn_check_top(a);
 	}
 
@@ -381,8 +412,8 @@
 		}
 
 #else
-	memset(A,0,sizeof(BN_ULONG)*words);
-	memcpy(A,b->d,sizeof(b->d[0])*b->top);
+	op_memset(A,0,sizeof(BN_ULONG)*words);
+	op_memcpy(A,b->d,sizeof(b->d[0])*b->top);
 #endif
 		
 	return(a);
@@ -399,6 +430,7 @@
  * while bn_dup_expand() makes sure allocation is made only once.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_DEPRECATED
 BIGNUM *bn_dup_expand(const BIGNUM *b, int words)
 	{
@@ -444,6 +476,7 @@
 	return r;
 	}
 #endif
+#endif
 
 /* This is an internal function that should not be used in applications.
  * It ensures that 'b' has enough room for a 'words' word number
@@ -531,7 +564,7 @@
 		case 0: ; /* ultrix cc workaround, see comments in bn_expand_internal */
 		}
 #else
-	memcpy(a->d,b->d,sizeof(b->d[0])*b->top);
+	op_memcpy(a->d,b->d,sizeof(b->d[0])*b->top);
 #endif
 
 	a->top=b->top;
@@ -540,6 +573,7 @@
 	return(a);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 void BN_swap(BIGNUM *a, BIGNUM *b)
 	{
 	int flags_old_a, flags_old_b;
@@ -572,16 +606,18 @@
 	bn_check_top(a);
 	bn_check_top(b);
 	}
+#endif
 
 void BN_clear(BIGNUM *a)
 	{
 	bn_check_top(a);
 	if (a->d != NULL)
-		memset(a->d,0,a->dmax*sizeof(a->d[0]));
+		op_memset(a->d,0,a->dmax*sizeof(a->d[0]));
 	a->top=0;
 	a->neg=0;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 BN_ULONG BN_get_word(const BIGNUM *a)
 	{
 	if (a->top > 1)
@@ -591,6 +627,7 @@
 	/* a->top == 0 */
 	return 0;
 	}
+#endif
 
 int BN_set_word(BIGNUM *a, BN_ULONG w)
 	{
@@ -747,6 +784,7 @@
 	return(1);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int BN_clear_bit(BIGNUM *a, int n)
 	{
 	int i,j;
@@ -762,6 +800,7 @@
 	bn_correct_top(a);
 	return(1);
 	}
+#endif
 
 int BN_is_bit_set(const BIGNUM *a, int n)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_mod.c openssl-1.0.0q/crypto/bn/bn_mod.c
--- openssl-1.0.0q.orig/crypto/bn/bn_mod.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_mod.c	2017-04-25 16:23:40.077527727 +0200
@@ -111,7 +111,7 @@
  * [including the GNU Public Licence.]
  */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 
@@ -138,6 +138,7 @@
 }
 
 
+#ifndef OPERA_SMALL_VERSION
 int BN_mod_add(BIGNUM *r, const BIGNUM *a, const BIGNUM *b, const BIGNUM *m, BN_CTX *ctx)
 	{
 	if (!BN_add(r, a, b)) return 0;
@@ -172,6 +173,7 @@
 		return BN_add(r, r, m);
 	return 1;
 	}
+#endif
 
 
 /* slow but works */
@@ -200,6 +202,7 @@
 	}
 
 
+#ifndef OPERA_SMALL_VERSION
 int BN_mod_sqr(BIGNUM *r, const BIGNUM *a, const BIGNUM *m, BN_CTX *ctx)
 	{
 	if (!BN_sqr(r, a, ctx)) return 0;
@@ -299,3 +302,4 @@
 	
 	return 1;
 	}
+#endif /* #ifndef OPERA_SMALL_VERSION */
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_mont.c openssl-1.0.0q/crypto/bn/bn_mont.c
--- openssl-1.0.0q.orig/crypto/bn/bn_mont.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_mont.c	2017-04-25 16:23:40.078527296 +0200
@@ -116,8 +116,10 @@
  * sections 3.8 and 4.2 in http://security.ece.orst.edu/koc/papers/r01rsasw.pdf
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 #define MONT_WORD /* use the faster word-based algorithm */
@@ -201,7 +203,7 @@
 	for (i=r->top; i<max; i++) /* memset? XXX */
 		r->d[i]=0;
 #else
-	memset(&(r->d[r->top]),0,(max-r->top)*sizeof(BN_ULONG)); 
+	op_memset(&(r->d[r->top]),0,(max-r->top)*sizeof(BN_ULONG)); 
 #endif
 
 	r->top=max;
@@ -520,6 +522,7 @@
 	return ret;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 BN_MONT_CTX *BN_MONT_CTX_copy(BN_MONT_CTX *to, BN_MONT_CTX *from)
 	{
 	if (to == from) return(to);
@@ -532,6 +535,7 @@
 	to->n0[1]=from->n0[1];
 	return(to);
 	}
+#endif
 
 BN_MONT_CTX *BN_MONT_CTX_set_locked(BN_MONT_CTX **pmont, int lock,
 					const BIGNUM *mod, BN_CTX *ctx)
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_mpi.c openssl-1.0.0q/crypto/bn/bn_mpi.c
--- openssl-1.0.0q.orig/crypto/bn/bn_mpi.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_mpi.c	2017-04-25 16:23:40.079527982 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include "bn_lcl.h"
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_mul.c openssl-1.0.0q/crypto/bn/bn_mul.c
--- openssl-1.0.0q.orig/crypto/bn/bn_mul.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_mul.c	2017-04-25 16:23:40.080526432 +0200
@@ -56,6 +56,7 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #ifndef BN_DEBUG
 # undef NDEBUG /* avoid conflicting definitions */
 # define NDEBUG
@@ -63,8 +64,9 @@
 
 #include <stdio.h>
 #include <assert.h>
-#include "cryptlib.h"
-#include "bn_lcl.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#include "modules/libopeay/crypto/bn/bn_lcl.h"
 
 #if defined(OPENSSL_NO_ASM) || !defined(OPENSSL_BN_ASM_PART_WORDS)
 /* Here follows specialised variants of bn_add_words() and
@@ -204,6 +206,7 @@
 	}
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 BN_ULONG bn_add_part_words(BN_ULONG *r,
 	const BN_ULONG *a, const BN_ULONG *b,
 	int cl, int dl)
@@ -374,6 +377,7 @@
 		}
 	return c;
 	}
+#endif
 
 #ifdef BN_RECURSION
 /* Karatsuba recursive multiplication algorithm
@@ -423,7 +427,7 @@
 		{
 		bn_mul_normal(r,a,n2+dna,b,n2+dnb);
 		if ((dna + dnb) < 0)
-			memset(&r[2*n2 + dna + dnb], 0,
+			op_memset(&r[2*n2 + dna + dnb], 0,
 				sizeof(BN_ULONG) * -(dna + dnb));
 		return;
 		}
@@ -471,7 +475,7 @@
 		if (!zero)
 			bn_mul_comba4(&(t[n2]),t,&(t[n]));
 		else
-			memset(&(t[n2]),0,8*sizeof(BN_ULONG));
+			op_memset(&(t[n2]),0,8*sizeof(BN_ULONG));
 		
 		bn_mul_comba4(r,a,b);
 		bn_mul_comba4(&(r[n2]),&(a[n]),&(b[n]));
@@ -483,7 +487,7 @@
 		if (!zero)
 			bn_mul_comba8(&(t[n2]),t,&(t[n]));
 		else
-			memset(&(t[n2]),0,16*sizeof(BN_ULONG));
+			op_memset(&(t[n2]),0,16*sizeof(BN_ULONG));
 		
 		bn_mul_comba8(r,a,b);
 		bn_mul_comba8(&(r[n2]),&(a[n]),&(b[n]));
@@ -495,7 +499,7 @@
 		if (!zero)
 			bn_mul_recursive(&(t[n2]),t,&(t[n]),n,0,0,p);
 		else
-			memset(&(t[n2]),0,n2*sizeof(BN_ULONG));
+			op_memset(&(t[n2]),0,n2*sizeof(BN_ULONG));
 		bn_mul_recursive(r,a,b,n,0,0,p);
 		bn_mul_recursive(&(r[n2]),&(a[n]),&(b[n]),n,dna,dnb,p);
 		}
@@ -605,7 +609,7 @@
 		bn_mul_comba4(&(t[n2]),t,&(t[n]));
 		bn_mul_comba4(r,a,b);
 		bn_mul_normal(&(r[n2]),&(a[n]),tn,&(b[n]),tn);
-		memset(&(r[n2+tn*2]),0,sizeof(BN_ULONG)*(n2-tn*2));
+		op_memset(&(r[n2+tn*2]),0,sizeof(BN_ULONG)*(n2-tn*2));
 		}
 	else
 # endif
@@ -614,7 +618,7 @@
 		bn_mul_comba8(&(t[n2]),t,&(t[n]));
 		bn_mul_comba8(r,a,b);
 		bn_mul_normal(&(r[n2]),&(a[n]),tna,&(b[n]),tnb);
-		memset(&(r[n2+tna+tnb]),0,sizeof(BN_ULONG)*(n2-tna-tnb));
+		op_memset(&(r[n2+tna+tnb]),0,sizeof(BN_ULONG)*(n2-tna-tnb));
 		}
 	else
 		{
@@ -632,18 +636,18 @@
 			{
 			bn_mul_recursive(&(r[n2]),&(a[n]),&(b[n]),
 				i,tna-i,tnb-i,p);
-			memset(&(r[n2+i*2]),0,sizeof(BN_ULONG)*(n2-i*2));
+			op_memset(&(r[n2+i*2]),0,sizeof(BN_ULONG)*(n2-i*2));
 			}
 		else if (j > 0) /* eg, n == 16, i == 8 and tn == 11 */
 				{
 				bn_mul_part_recursive(&(r[n2]),&(a[n]),&(b[n]),
 					i,tna-i,tnb-i,p);
-				memset(&(r[n2+tna+tnb]),0,
+				op_memset(&(r[n2+tna+tnb]),0,
 					sizeof(BN_ULONG)*(n2-tna-tnb));
 				}
 		else /* (j < 0) eg, n == 16, i == 8 and tn == 5 */
 			{
-			memset(&(r[n2]),0,sizeof(BN_ULONG)*n2);
+			op_memset(&(r[n2]),0,sizeof(BN_ULONG)*n2);
 			if (tna < BN_MUL_RECURSIVE_SIZE_NORMAL
 				&& tnb < BN_MUL_RECURSIVE_SIZE_NORMAL)
 				{
@@ -720,6 +724,7 @@
 		}
 	}
 
+#ifndef OPERA_SMALL_VERSION
 /* a and b must be the same size, which is n2.
  * r needs to be n2 words and t needs to be n2*2
  */
@@ -748,12 +753,14 @@
 		bn_add_words(&(r[n]),&(r[n]),&(t[n]),n);
 		}
 	}
+#endif
 
 /* a and b must be the same size, which is n2.
  * r needs to be n2 words and t needs to be n2*2
  * l is the low words of the output.
  * t needs to be n2*3
  */
+#ifndef OPERA_SMALL_VERSION
 void bn_mul_high(BN_ULONG *r, BN_ULONG *a, BN_ULONG *b, BN_ULONG *l, int n2,
 	     BN_ULONG *t)
 	{
@@ -938,6 +945,7 @@
 			}
 		}
 	}
+#endif /* #ifndef OPERA_SMALL_VERSION */
 #endif /* BN_RECURSION */
 
 int BN_mul(BIGNUM *r, const BIGNUM *a, const BIGNUM *b, BN_CTX *ctx)
@@ -1143,6 +1151,7 @@
 		}
 	}
 
+#ifndef OPERA_SMALL_VERSION
 void bn_mul_low_normal(BN_ULONG *r, BN_ULONG *a, BN_ULONG *b, int n)
 	{
 #ifdef BN_COUNT
@@ -1164,3 +1173,4 @@
 		b+=4;
 		}
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_prime.c openssl-1.0.0q/crypto/bn/bn_prime.c
--- openssl-1.0.0q.orig/crypto/bn/bn_prime.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_prime.c	2017-04-25 16:23:40.081527118 +0200
@@ -109,9 +109,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 #include <openssl/rand.h>
 
@@ -235,10 +237,12 @@
 	return found;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int BN_is_prime_ex(const BIGNUM *a, int checks, BN_CTX *ctx_passed, BN_GENCB *cb)
 	{
 	return BN_is_prime_fasttest_ex(a, checks, ctx_passed, 0, cb);
 	}
+#endif
 
 int BN_is_prime_fasttest_ex(const BIGNUM *a, int checks, BN_CTX *ctx_passed,
 		int do_trial_division, BN_GENCB *cb)
@@ -276,7 +280,7 @@
 			goto err;
 	BN_CTX_start(ctx);
 
-	/* A := abs(a) */
+	/* A := op_abs(a) */
 	if (a->neg)
 		{
 		BIGNUM *t;
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_print.c openssl-1.0.0q/crypto/bn/bn_print.c
--- openssl-1.0.0q.orig/crypto/bn/bn_print.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_print.c	2017-04-25 16:23:40.082527525 +0200
@@ -56,13 +56,16 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include "bn_lcl.h"
 
-static const char Hex[]="0123456789ABCDEF";
+#ifndef OPERA_SMALL_VERSION
+static const char Hex[]="0123456789ABCDEF";/* ARRAY OK 2007-02-27 haavardm */
 
 /* Must 'OPENSSL_free' the returned data */
 char *BN_bn2hex(const BIGNUM *a)
@@ -98,6 +101,7 @@
 err:
 	return(buf);
 	}
+#endif //OPERA_SMALL_VERSION
 
 /* Must 'OPENSSL_free' the returned data */
 char *BN_bn2dec(const BIGNUM *a)
@@ -180,7 +184,7 @@
 
 	if (*a == '-') { neg=1; a++; }
 
-	for (i=0; isxdigit((unsigned char) a[i]); i++)
+	for (i=0; op_isxdigit((unsigned char) a[i]); i++)
 		;
 
 	num=i+neg;
@@ -246,7 +250,7 @@
 	if ((a == NULL) || (*a == '\0')) return(0);
 	if (*a == '-') { neg=1; a++; }
 
-	for (i=0; isdigit((unsigned char) a[i]); i++)
+	for (i=0; op_isdigit((unsigned char) a[i]); i++)
 		;
 
 	num=i+neg;
@@ -331,6 +335,7 @@
 	}
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 int BN_print(BIO *bp, const BIGNUM *a)
 	{
 	int i,j,v,z=0;
@@ -357,3 +362,4 @@
 	return(ret);
 	}
 #endif
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_rand.c openssl-1.0.0q/crypto/bn/bn_rand.c
--- openssl-1.0.0q.orig/crypto/bn/bn_rand.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_rand.c	2017-04-25 16:23:40.083527093 +0200
@@ -109,9 +109,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 #include <openssl/rand.h>
 
@@ -138,22 +140,30 @@
 		goto err;
 		}
 
+#ifdef VALGRIND
+	op_memset(&tim,0,sizeof(tim));
+	op_memset(buf,0,bytes);
+#endif
+
 	/* make a random number and set the top and bottom bits */
-	time(&tim);
+	op_time(&tim);
 	RAND_add(&tim,sizeof(tim),0.0);
 
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 	if (pseudorand)
 		{
 		if (RAND_pseudo_bytes(buf, bytes) == -1)
 			goto err;
 		}
 	else
+#endif
 		{
 		if (RAND_bytes(buf, bytes) <= 0)
 			goto err;
 		}
 
 #if 1
+#ifndef OPERA_SMALL_VERSION
 	if (pseudorand == 2)
 		{
 		/* generate patterns that are more likely to trigger BN
@@ -173,6 +183,7 @@
 			}
 		}
 #endif
+#endif
 
 	if (top != -1)
 		{
@@ -213,23 +224,29 @@
 	return bnrand(0, rnd, bits, top, bottom);
 	}
 
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
 int     BN_pseudo_rand(BIGNUM *rnd, int bits, int top, int bottom)
 	{
 	return bnrand(1, rnd, bits, top, bottom);
 	}
+#endif
 
 #if 1
+#ifndef OPERA_SMALL_VERSION
 int     BN_bntest_rand(BIGNUM *rnd, int bits, int top, int bottom)
 	{
 	return bnrand(2, rnd, bits, top, bottom);
 	}
 #endif
+#endif
 
 
 /* random number r:  0 <= r < range */
 static int bn_rand_range(int pseudo, BIGNUM *r, const BIGNUM *range)
 	{
-	int (*bn_rand)(BIGNUM *, int, int, int) = pseudo ? BN_pseudo_rand : BN_rand;
+	/* Although the handling of pseudo to chose between BN_rand and
+	 * BN_pseudo_rand could more cleanly be done via a function pointer, doing
+	 * so crashes the ADS1.2 compiler used by BREW; see bug 329079 :-( */
 	int n;
 	int count = 100;
 
@@ -251,7 +268,14 @@
 		 * so  3*range (= 11..._2)  is exactly one bit longer than  range */
 		do
 			{
-			if (!bn_rand(r, n + 1, -1, 0)) return 0;
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+			if (pseudo)
+			    {
+			    if (!BN_pseudo_rand(r, n + 1, -1, 0)) return 0;
+			    }
+			else
+#endif
+			if (!BN_rand(r, n + 1, -1, 0)) return 0;
 			/* If  r < 3*range,  use  r := r MOD range
 			 * (which is either  r, r - range,  or  r - 2*range).
 			 * Otherwise, iterate once more.
@@ -278,7 +302,14 @@
 		do
 			{
 			/* range = 11..._2  or  range = 101..._2 */
-			if (!bn_rand(r, n, -1, 0)) return 0;
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+			if (pseudo)
+			    {
+				if (!BN_pseudo_rand(r, n, -1, 0)) return 0;
+			    }
+			else
+#endif
+			if (!BN_rand(r, n, -1, 0)) return 0;
 
 			if (!--count)
 				{
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_recp.c openssl-1.0.0q/crypto/bn/bn_recp.c
--- openssl-1.0.0q.orig/crypto/bn/bn_recp.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_recp.c	2017-04-25 16:23:40.084527220 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#if !defined OPERA_SMALL_VERSION || defined LIBOPEAY_PKCS12_SUPPORT || defined(NEED_LIBOPEAY_ELGAMAL)
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 void BN_RECP_CTX_init(BN_RECP_CTX *recp)
@@ -68,6 +71,7 @@
 	recp->flags=0;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 BN_RECP_CTX *BN_RECP_CTX_new(void)
 	{
 	BN_RECP_CTX *ret;
@@ -79,6 +83,7 @@
 	ret->flags=BN_FLG_MALLOCED;
 	return(ret);
 	}
+#endif
 
 void BN_RECP_CTX_free(BN_RECP_CTX *recp)
 	{
@@ -232,3 +237,4 @@
 	BN_CTX_end(ctx);
 	return(ret);
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_shift.c openssl-1.0.0q/crypto/bn/bn_shift.c
--- openssl-1.0.0q.orig/crypto/bn/bn_shift.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_shift.c	2017-04-25 16:23:40.085527068 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 int BN_lshift1(BIGNUM *r, const BIGNUM *a)
@@ -156,7 +158,7 @@
 			t[nw+i+1]|=(l>>rb)&BN_MASK2;
 			t[nw+i]=(l<<lb)&BN_MASK2;
 			}
-	memset(t,0,nw*sizeof(t[0]));
+	op_memset(t,0,nw*sizeof(t[0]));
 /*	for (i=0; i<nw; i++)
 		t[i]=0;*/
 	r->top=a->top+nw+1;
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_sqr.c openssl-1.0.0q/crypto/bn/bn_sqr.c
--- openssl-1.0.0q.orig/crypto/bn/bn_sqr.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_sqr.c	2017-04-25 16:23:40.086527195 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 /* r must not be a */
@@ -252,7 +254,7 @@
 	if (!zero)
 		bn_sqr_recursive(&(t[n2]),t,n,p);
 	else
-		memset(&(t[n2]),0,n2*sizeof(BN_ULONG));
+		op_memset(&(t[n2]),0,n2*sizeof(BN_ULONG));
 	bn_sqr_recursive(r,a,n,p);
 	bn_sqr_recursive(&(r[n2]),&(a[n]),n,p);
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_sqrt.c openssl-1.0.0q/crypto/bn/bn_sqrt.c
--- openssl-1.0.0q.orig/crypto/bn/bn_sqrt.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_sqrt.c	2017-04-25 16:23:40.086527195 +0200
@@ -83,8 +83,7 @@
 				goto end;
 			if (!BN_set_word(ret, BN_is_bit_set(a, 0)))
 				{
-				if (ret != in)
-					BN_free(ret);
+				BN_free(ret);
 				return NULL;
 				}
 			bn_check_top(ret);
@@ -103,8 +102,7 @@
 			goto end;
 		if (!BN_set_word(ret, BN_is_one(a)))
 			{
-			if (ret != in)
-				BN_free(ret);
+			BN_free(ret);
 			return NULL;
 			}
 		bn_check_top(ret);
diff -Naur openssl-1.0.0q.orig/crypto/bn/bn_word.c openssl-1.0.0q/crypto/bn/bn_word.c
--- openssl-1.0.0q.orig/crypto/bn/bn_word.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bn_word.c	2017-04-25 16:23:40.087527043 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "bn_lcl.h"
 
 BN_ULONG BN_mod_word(const BIGNUM *a, BN_ULONG w)
diff -Naur openssl-1.0.0q.orig/crypto/bn/bnspeed.c openssl-1.0.0q/crypto/bn/bnspeed.c
--- openssl-1.0.0q.orig/crypto/bn/bnspeed.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bnspeed.c	2017-04-25 16:23:40.088527449 +0200
@@ -64,10 +64,14 @@
 #undef PROG
 #define PROG bnspeed_main
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <signal.h>
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/crypto.h>
 #include <openssl/err.h>
 
@@ -76,10 +80,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -97,7 +105,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/bntest.c openssl-1.0.0q/crypto/bn/bntest.c
--- openssl-1.0.0q.orig/crypto/bn/bntest.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/bntest.c	2017-04-25 16:23:40.089526459 +0200
@@ -75,9 +75,11 @@
 #undef OPENSSL_NO_DEPRECATED
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "e_os.h"
 
@@ -149,9 +151,9 @@
 	argv++;
 	while (argc >= 1)
 		{
-		if (strcmp(*argv,"-results") == 0)
+		if (op_strcmp(*argv,"-results") == 0)
 			results=1;
-		else if (strcmp(*argv,"-out") == 0)
+		else if (op_strcmp(*argv,"-out") == 0)
 			{
 			if (--argc < 1) break;
 			outfile= *(++argv);
diff -Naur openssl-1.0.0q.orig/crypto/bn/exp.c openssl-1.0.0q/crypto/bn/exp.c
--- openssl-1.0.0q.orig/crypto/bn/exp.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/exp.c	2017-04-25 16:23:40.090526307 +0200
@@ -1,6 +1,8 @@
 /* unused */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/tmdiff.h>
 #include "bn_lcl.h"
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/expspeed.c openssl-1.0.0q/crypto/bn/expspeed.c
--- openssl-1.0.0q.orig/crypto/bn/expspeed.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/expspeed.c	2017-04-25 16:23:40.091526434 +0200
@@ -89,10 +89,14 @@
 #undef PROG
 #define PROG bnspeed_main
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <signal.h>
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/crypto.h>
 #include <openssl/err.h>
 #include <openssl/rand.h>
@@ -102,10 +106,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -123,7 +131,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/exptest.c openssl-1.0.0q/crypto/bn/exptest.c
--- openssl-1.0.0q.orig/crypto/bn/exptest.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/exptest.c	2017-04-25 16:23:40.092526002 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
diff -Naur openssl-1.0.0q.orig/crypto/bn/opera_bn_blind.cpp openssl-1.0.0q/crypto/bn/opera_bn_blind.cpp
--- openssl-1.0.0q.orig/crypto/bn/opera_bn_blind.cpp	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/opera_bn_blind.cpp	2017-04-25 16:23:40.094527095 +0200
@@ -0,0 +1,15 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#if defined(_SSL_USE_OPENSSL_) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
+extern "C" {
+#include "bn_blind.c"
+}
+#endif // _SSL_USE_OPENSSL_
diff -Naur openssl-1.0.0q.orig/crypto/bn/vms-helper.c openssl-1.0.0q/crypto/bn/vms-helper.c
--- openssl-1.0.0q.orig/crypto/bn/vms-helper.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/bn/vms-helper.c	2017-04-25 16:23:40.105527375 +0200
@@ -53,7 +53,9 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include "bn_lcl.h"
 
diff -Naur openssl-1.0.0q.orig/crypto/buffer/.gitignore openssl-1.0.0q/crypto/buffer/.gitignore
--- openssl-1.0.0q.orig/crypto/buffer/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/buffer/.gitignore	2017-04-25 16:23:40.106526944 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/buffer/buf_err.c openssl-1.0.0q/crypto/buffer/buf_err.c
--- openssl-1.0.0q.orig/crypto/buffer/buf_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/buffer/buf_err.c	2017-04-25 16:23:40.106526944 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/buffer.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/buffer/buffer.c openssl-1.0.0q/crypto/buffer/buffer.c
--- openssl-1.0.0q.orig/crypto/buffer/buffer.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/buffer/buffer.c	2017-04-25 16:23:40.107527071 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/buffer.h>
 
@@ -69,7 +71,7 @@
 	{
 	BUF_MEM *ret;
 
-	ret=OPENSSL_malloc(sizeof(BUF_MEM));
+	ret= (BUF_MEM *) OPENSSL_malloc(sizeof(BUF_MEM));
 	if (ret == NULL)
 		{
 		BUFerr(BUF_F_BUF_MEM_NEW,ERR_R_MALLOC_FAILURE);
@@ -88,7 +90,7 @@
 
 	if (a->data != NULL)
 		{
-		memset(a->data,0,(unsigned int)a->max);
+		op_memset(a->data,0,(unsigned int)a->max);
 		OPENSSL_free(a->data);
 		}
 	OPENSSL_free(a);
@@ -106,7 +108,7 @@
 		}
 	if (str->max >= len)
 		{
-		memset(&str->data[str->length],0,len-str->length);
+		op_memset(&str->data[str->length],0,len-str->length);
 		str->length=len;
 		return(len);
 		}
@@ -118,9 +120,9 @@
 		}
 	n=(len+3)/3*4;
 	if (str->data == NULL)
-		ret=OPENSSL_malloc(n);
+		ret=(char *) OPENSSL_malloc(n);
 	else
-		ret=OPENSSL_realloc(str->data,n);
+		ret=(char *) OPENSSL_realloc(str->data,n);
 	if (ret == NULL)
 		{
 		BUFerr(BUF_F_BUF_MEM_GROW,ERR_R_MALLOC_FAILURE);
@@ -130,7 +132,7 @@
 		{
 		str->data=ret;
 		str->max=n;
-		memset(&str->data[str->length],0,len-str->length);
+		op_memset(&str->data[str->length],0,len-str->length);
 		str->length=len;
 		}
 	return(len);
@@ -143,13 +145,13 @@
 
 	if (str->length >= len)
 		{
-		memset(&str->data[len],0,str->length-len);
+		op_memset(&str->data[len],0,str->length-len);
 		str->length=len;
 		return(len);
 		}
 	if (str->max >= len)
 		{
-		memset(&str->data[str->length],0,len-str->length);
+		op_memset(&str->data[str->length],0,len-str->length);
 		str->length=len;
 		return(len);
 		}
@@ -161,9 +163,9 @@
 		}
 	n=(len+3)/3*4;
 	if (str->data == NULL)
-		ret=OPENSSL_malloc(n);
+		ret=(char *) OPENSSL_malloc(n);
 	else
-		ret=OPENSSL_realloc_clean(str->data,str->max,n);
+		ret=(char *) OPENSSL_realloc_clean(str->data,str->max,n);
 	if (ret == NULL)
 		{
 		BUFerr(BUF_F_BUF_MEM_GROW_CLEAN,ERR_R_MALLOC_FAILURE);
@@ -173,7 +175,7 @@
 		{
 		str->data=ret;
 		str->max=n;
-		memset(&str->data[str->length],0,len-str->length);
+		op_memset(&str->data[str->length],0,len-str->length);
 		str->length=len;
 		}
 	return(len);
@@ -182,7 +184,7 @@
 char *BUF_strdup(const char *str)
 	{
 	if (str == NULL) return(NULL);
-	return BUF_strndup(str, strlen(str));
+	return BUF_strndup(str, op_strlen(str));
 	}
 
 char *BUF_strndup(const char *str, size_t siz)
@@ -191,7 +193,7 @@
 
 	if (str == NULL) return(NULL);
 
-	ret=OPENSSL_malloc(siz+1);
+	ret=(char *) OPENSSL_malloc(siz+1);
 	if (ret == NULL) 
 		{
 		BUFerr(BUF_F_BUF_STRNDUP,ERR_R_MALLOC_FAILURE);
@@ -226,7 +228,7 @@
 		}
 	if (size)
 		*dst = '\0';
-	return l + strlen(src);
+	return l + op_strlen(src);
 	}
 
 size_t BUF_strlcat(char *dst, const char *src, size_t size)
diff -Naur openssl-1.0.0q.orig/crypto/buffer/buffer.h openssl-1.0.0q/crypto/buffer/buffer.h
--- openssl-1.0.0q.orig/crypto/buffer/buffer.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/buffer/buffer.h	2017-04-25 16:23:40.113526995 +0200
@@ -65,11 +65,13 @@
 extern "C" {
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
 
 #if !defined(NO_SYS_TYPES_H)
 #include <sys/types.h>
 #endif
+#endif /* !OPERA_SMALL_VERSION */
 
 /* Already declared in ossl_typ.h */
 /* typedef struct buf_mem_st BUF_MEM; */
diff -Naur openssl-1.0.0q.orig/crypto/camellia/.gitignore openssl-1.0.0q/crypto/camellia/.gitignore
--- openssl-1.0.0q.orig/crypto/camellia/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/camellia/.gitignore	2017-04-25 16:23:40.115526970 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/cast/.gitignore openssl-1.0.0q/crypto/cast/.gitignore
--- openssl-1.0.0q.orig/crypto/cast/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/.gitignore	2017-04-25 16:23:40.115526970 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/cast/c_cfb64.c openssl-1.0.0q/crypto/cast/c_cfb64.c
--- openssl-1.0.0q.orig/crypto/cast/c_cfb64.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/cast/c_cfb64.c	2017-04-25 16:23:40.116526818 +0200
@@ -56,6 +56,8 @@
  * [including the GNU Public Licence.]
  */
 
+#if !defined OPENSSL_NO_CAST && defined OPENSSL_USE_CFB_CIPHERS
+
 #include <openssl/cast.h>
 #include "cast_lcl.h"
 
@@ -119,3 +121,4 @@
 	v0=v1=ti[0]=ti[1]=t=c=cc=0;
 	*num=n;
 	}
+#endif
